//
//  EndView.m
//  长按结束(防keep)
//
//  Created by 栗子 on 2017/7/17.
//  Copyright © 2017年 栗子. All rights reserved.
//




#import "EndView.h"


@interface EndView ()
{
    NSMutableArray *timeArray;
    
}
@property(nonatomic,strong)UIView *bgVIew;

@property (nonatomic, weak) CAShapeLayer *progressLayer;
@property (nonatomic,weak)  UIBezierPath *path;
@property (nonatomic,weak) CAShapeLayer *trackLayer;
@property (nonatomic,strong)UIView *samllView;
@property (nonatomic,strong) UILabel *endLB;

@end


@implementation EndView
-(instancetype)initWithFrame:(CGRect)frame{
    if (self =[super initWithFrame:frame]) {
        timeArray=[NSMutableArray array];
        self.bgVIew=[[UIView alloc]init];//61665f
        self.bgVIew.backgroundColor=[LColor(0, 0, 0)colorWithAlphaComponent:0.4];
        
        [self addSubview:self.bgVIew];
        self.endLB=[[UILabel alloc]init];
        [self bgViewSmallFrame];
        self.endLB.textColor=[UIColor whiteColor];
        self.endLB.font=[UIFont systemFontOfSize:20];
        [self.bgVIew addSubview:self.endLB];
        self.endLB.textAlignment=NSTextAlignmentCenter;
        UILongPressGestureRecognizer *longPG=[[UILongPressGestureRecognizer alloc]initWithTarget:self action:@selector(longPG:)];
        [self addGestureRecognizer:longPG];
        longPG.minimumPressDuration = 0.1;
    }
    return self;
    
}
-(void)bgViewSmallFrame{
    
    self.bgVIew.frame=CGRectMake(20 , 20, 80, 80);
    self.bgVIew.layer.cornerRadius= self.bgVIew.frame.size.width/2;
    self.bgVIew.layer.masksToBounds=YES;
    self.endLB.frame=CGRectMake(0,(self.bgVIew.frame.size.height-20)/2 , 80, 20);
    self.endLB.text=@"结束";
    
}
-(void)bgVIewBigFrame{
    self.bgVIew.frame=CGRectMake(10, 10, 100, 100);
    self.bgVIew.layer.cornerRadius= self.bgVIew.frame.size.width/2;;
    self.bgVIew.layer.masksToBounds=YES;
    self.endLB.frame=CGRectMake(0,(self.bgVIew.frame.size.height-20)/2 , 100, 20);
    self.endLB.text=@"长按";
    
}



-(void)longPG:(UILongPressGestureRecognizer *)pg{
    
    self.trackLayer.path = [self.path CGPath];
    switch (pg.state) {
        case UIGestureRecognizerStateBegan:{
            
            [self bgVIewBigFrame];
            [self show:YES];
            NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
            [dateFormatter setDateFormat:@"YYYY/MM/dd hh:mm:ss"];
            NSString * dateString = [dateFormatter stringFromDate:[NSDate date]];
            [timeArray addObject:dateString];
            [self setPercet:100 withTimer:4.0f];
            break;
        }
            
        case UIGestureRecognizerStateEnded:
            [self.samllView removeFromSuperview];
            [self bgViewSmallFrame];
            [self setPercet:00 withTimer:0.1];
            if ([Healp getTimeUTCFormateDate:timeArray[0]]>4) {
            if ([self.delegate respondsToSelector:@selector(endMatch)]) {
                [self.delegate endMatch];
            }
            }
            if (timeArray.count>0) {
                [timeArray removeAllObjects];
            }            
            break;
        case UIGestureRecognizerStateChanged:
        default:
            break;
    }
    
    
    
}


- (void)show:(BOOL)animated
{
    if (animated)
    {
        
        self.samllView.transform = CGAffineTransformMakeScale(0.6f , 0.6f);
        self.samllView.alpha = 0.0f;
        [UIView animateWithDuration:0.2 animations:^{
            self.samllView.transform = CGAffineTransformIdentity;
            self.samllView.alpha = 1.0f;
            self.samllView=[[UIView alloc]initWithFrame:CGRectMake(0, 0,120, 120)];//0xa3a5a2
            self.samllView.backgroundColor=[LColor(0xa3, 0xa5, 0xa2)colorWithAlphaComponent:0.6];
            self.samllView.layer.cornerRadius=120.0f/2;
            self.samllView.layer.borderColor=[UIColor whiteColor].CGColor;
            self.samllView.layer.borderWidth=0.5;
            self.samllView.layer.masksToBounds=YES;
            [self addSubview:_samllView];
            [self sendSubviewToBack:self.samllView];
        } completion:^(BOOL finished) {
            
        }];
    }
}


- (void)drawRect:(CGRect)rect {
    // 创建一个tracker(轨道layer)圆环内部
    CAShapeLayer *trackLayer = [CAShapeLayer layer];
    trackLayer.frame = rect;
    [self.layer addSublayer:trackLayer];
    trackLayer.fillColor =[LColor(0, 0, 0)colorWithAlphaComponent:0.5].CGColor;
    trackLayer.strokeColor = [UIColor whiteColor].CGColor;
    self.trackLayer=trackLayer;
    // 背景透明度
    trackLayer.opacity = 0.6f;
    trackLayer.lineCap = kCALineCapRound;
    trackLayer.lineWidth = PROGRESS_LINE_WIDTH;
    // 创建轨道
    UIBezierPath *path = [UIBezierPath bezierPathWithArcCenter:CGPointMake(rect.size.width / 2, rect.size.height / 2) radius:rect.size.width / 2 - PROGRESS_LINE_WIDTH / 2 startAngle:degreesToRadians(-90) endAngle:degreesToRadians(270) clockwise:YES];
    //    trackLayer.path = [path CGPath];
    self.path=path;
    path = [UIBezierPath bezierPathWithArcCenter:CGPointMake(rect.size.width / 2, rect.size.height / 2) radius:rect.size.width / 2 - PROGRESS_LINE_WIDTH / 2 startAngle:degreesToRadians(PROGRESS_LINE_WIDTH / 2 - 90) endAngle:degreesToRadians(270 - PROGRESS_LINE_WIDTH / 2) clockwise:YES];
    CAShapeLayer *progressLayer = [CAShapeLayer layer];
    progressLayer.frame = rect;
    progressLayer.fillColor = [UIColor clearColor].CGColor;
    progressLayer.strokeColor = [UIColor redColor].CGColor;
    progressLayer.lineCap = kCALineCapRound;
    progressLayer.lineWidth = PROGRESS_LINE_WIDTH;
    progressLayer.path = [path CGPath];
    progressLayer.strokeEnd = 0.00f;
    self.progressLayer = progressLayer;
    
    CALayer *gradientLayer = [CALayer layer];
    CAGradientLayer *gradientLayer1 = [CAGradientLayer layer];
    gradientLayer1.frame = CGRectMake(0, 0, rect.size.width , rect.size.height);
    [gradientLayer1 setColors:[NSArray arrayWithObjects:(id)[UIColorFromRGB(0x5c5e5b) CGColor],(id)[UIColorFromRGB(0xa8aaa7) CGColor],(id)[UIColorFromRGB(0xa8aaa7) CGColor], nil]];
    [gradientLayer1 setStartPoint:CGPointMake(0.5, 0)];
    [gradientLayer1 setEndPoint:CGPointMake(0.5, 1)];
    [gradientLayer addSublayer:gradientLayer1];
    
    //    CAGradientLayer *gradientLayer2 = [CAGradientLayer layer];//渐变圆环
    //    gradientLayer2.frame = CGRectMake(rect.size.width / 2, 0, rect.size.width / 2, rect.size.height);
    //    [gradientLayer2 setColors:[NSArray arrayWithObjects:(id)[UIColorFromRGB(0xa8aaa7) CGColor],(id)[UIColorFromRGB(0xa8aaa7) CGColor],(id)[UIColorFromRGB(0xa3a5a2) CGColor], nil]];
    //    [gradientLayer2 setStartPoint:CGPointMake(0.5, 0)];
    //    [gradientLayer2 setEndPoint:CGPointMake(0.5, 1)];
    //    [gradientLayer addSublayer:gradientLayer2];
    
    // progressLayer来截取渐变层, fill是clear stroke有颜色
    [gradientLayer setMask:progressLayer];
    [self.layer addSublayer:gradientLayer];
}

- (void)setPercet:(CGFloat)percent withTimer:(CGFloat)time {
    [CATransaction begin];
    [CATransaction setDisableActions:NO];
    [CATransaction setAnimationTimingFunction:[CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseOut]];
    [CATransaction setAnimationDuration:time];
    _progressLayer.strokeStart=0.00f;
    _progressLayer.strokeEnd = percent / 100.0f;
    [CATransaction commit];
}


@end
